Index: /branches/network/src/lib/network/network_game_manager.cc
===================================================================
--- /branches/network/src/lib/network/network_game_manager.cc	(revision 6664)
+++ /branches/network/src/lib/network/network_game_manager.cc	(revision 6665)
@@ -84,5 +84,5 @@
     if ( isServer() )
     {
-      if ( b == REQUEST_CREATE )
+      if ( b == NET_REQUEST_CREATE )
       {
         if ( !handleRequestCreate( i, data, length, sender ) )
@@ -90,5 +90,5 @@
         continue;
       }
-      if ( b == REQUEST_REMOVE )
+      if ( b == NET_REQUEST_REMOVE )
       {
         if ( !handleRequestRemove( i, data, length, sender ) )
@@ -99,5 +99,5 @@
     else
     {
-      if ( b == CREATE_ENTITY )
+      if ( b == NET_CREATE_ENTITY )
       {
         PRINTF(0)("CREATE_ENTITY\n");
@@ -106,5 +106,5 @@
         continue;
       }
-      if ( b == REMOVE_ENTITY )
+      if ( b == NET_REMOVE_ENTITY )
       {
         if ( !handleRemoveEntity( i, data, length, sender ) )
@@ -112,5 +112,5 @@
         continue;
       }
-      if ( b == CREATE_ENTITY_LIST )
+      if ( b == NET_CREATE_ENTITY_LIST )
       {
         if ( !handleCreateEntityList( i, data, length, sender ) )
@@ -118,5 +118,5 @@
         continue;
       }
-      if ( b == REMOVE_ENTITY_LIST )
+      if ( b == NET_REMOVE_ENTITY_LIST )
       {
         if ( !handleRemoveEntityList( i, data, length, sender ) )
@@ -124,5 +124,5 @@
         continue;
       }
-      if ( b == YOU_ARE_ENTITY )
+      if ( b == NET_YOU_ARE_ENTITY )
       {
         if ( !handleYouAreEntity( i, data, length, sender ) )
@@ -132,5 +132,5 @@
     }
 
-    if ( b == REQUEST_ENTITY_LIST )
+    if ( b == NET_REQUEST_ENTITY_LIST )
     {
       sendEntityList( sender );
@@ -138,5 +138,5 @@
     }
 
-    if ( b == REQUEST_SYNC )
+    if ( b == NET_REQUEST_SYNC )
     {
       if ( !handleRequestSync( i, data, length, sender ) )
@@ -261,4 +261,5 @@
   }
   else
+
   {
     PRINTF(1)("This node is not a server and cannot create id %x\n", element->Value());
@@ -298,5 +299,5 @@
       continue;
 
-    if ( !writeToClientBuffer( outBuffer[i], (byte)REQUEST_CREATE ) )
+    if ( !writeToClientBuffer( outBuffer[i], (byte)NET_REQUEST_CREATE ) )
       return;
     if ( !writeToClientBuffer( outBuffer[i], (int)classID ) )
@@ -316,5 +317,5 @@
       continue;
 
-    if ( !writeToClientBuffer( outBuffer[i], (byte)REQUEST_REMOVE ) )
+    if ( !writeToClientBuffer( outBuffer[i], (byte)NET_REQUEST_REMOVE ) )
       return;
     if ( !writeToClientBuffer( outBuffer[i], uniqueID ) )
@@ -335,5 +336,5 @@
       continue;
 
-    if ( !writeToClientBuffer( outBuffer[i], (byte)CREATE_ENTITY ) )
+    if ( !writeToClientBuffer( outBuffer[i], (byte)NET_CREATE_ENTITY ) )
       return -1;
     if ( !writeToClientBuffer( outBuffer[i], (int)classID ) )
@@ -362,5 +363,5 @@
       continue;
 
-    if ( !writeToClientBuffer( outBuffer[i], (byte)REMOVE_ENTITY ) )
+    if ( !writeToClientBuffer( outBuffer[i], (byte)NET_REMOVE_ENTITY ) )
       return;
     if ( !writeToClientBuffer( outBuffer[i], uniqueID ) )
@@ -397,5 +398,5 @@
   e = this->networkStream->getSyncEnd();
 
-  if ( !writeToClientBuffer( outBuffer[userID], (byte)CREATE_ENTITY_LIST ) )
+  if ( !writeToClientBuffer( outBuffer[userID], (byte)NET_CREATE_ENTITY_LIST ) )
     return;
 
@@ -485,4 +486,5 @@
     s->setUniqueID( uniqueID );
     s->setOwner( owner );
+    s->setSynchronized(true);
     //this->networkStream->connectSynchronizeable( *s );
     if ( !isServer() )
Index: /branches/network/src/lib/network/network_game_manager.h
===================================================================
--- /branches/network/src/lib/network/network_game_manager.h	(revision 6664)
+++ /branches/network/src/lib/network/network_game_manager.h	(revision 6665)
@@ -19,12 +19,14 @@
  * protocol definition
  *
- *  CREATE_ENTITY:       CLASS_ID, UNIQUE_ID, OWNER
- *  REMOVE_ENTITY:       UNIQUE_ID
+ *  CREATE_ENTITY:       >> CLASS_ID, UNIQUE_ID, OWNER
+ *  REMOVE_ENTITY:       >> UNIQUE_ID
  *
- *  CREATE_ENTITY_LIST:  NUMBER, [CLASS_ID, UNIQUE_ID, OWNER][0..NUMBER]
- *  REMOVE_ENTITY_LIST:  NUMBER, [UNIQUE_ID][0..NUMBER]
+ *  CREATE_ENTITY_LIST:  >> NUMBER, [CLASS_ID, UNIQUE_ID, OWNER][0..NUMBER]
+ *  REMOVE_ENTITY_LIST:  >> NUMBER, [UNIQUE_ID][0..NUMBER]
  *
- *  REQUEST_CREATE:      CLASS_ID
- *  REQUEST_REMOVE:      UNIQUE_ID
+ *  REQUEST_CREATE:      >> CLASS_ID
+ *                       << [Sync Info]
+ *  REQUEST_REMOVE:      >> UNIQUE_ID
+ *                       << [Sync Info]
  *
  *  //REQUEST_CREATE_LIST: NUMBER, [CLASS_ID][0..NUMBER]
@@ -32,21 +34,28 @@
  *
  *  REQUEST_ENTITY_LIST: //request the whole world :D
- *  REQUEST_SYNC:        UNIQUE_ID
+ *  REQUEST_SYNC:        >> UNIQUE_ID
+ *                       << [Sync Info]
  *  //REQUEST_SYNC_LIST:   NUMBER, [UNIQUE_ID][0..NUMBER]
  *
- *  YOU_ARE_ENTITY:      UNIQUE_ID
+ *  YOU_ARE_ENTITY:      >> UNIQUE_ID
+ *
+ *  REQUEST_PNODE_PATH   >> UNIQUE_ID_START   UNIQUE_ID_STOP
+ *                       << UNIQUE_ID_1   UNIQUE_ID_2   UNIQUE_ID_3 ...   UNIQUE_ID_N
  *
  */
 
 typedef enum NetworkGameManagerProtocol{
-  CREATE_ENTITY = 0,
-  REMOVE_ENTITY,
-  CREATE_ENTITY_LIST,
-  REMOVE_ENTITY_LIST,
-  REQUEST_CREATE,
-  REQUEST_REMOVE,
-  REQUEST_SYNC,
-  YOU_ARE_ENTITY,
-  REQUEST_ENTITY_LIST
+  NET_CREATE_ENTITY = 0,
+  NET_REMOVE_ENTITY,
+  NET_CREATE_ENTITY_LIST,
+  NET_REMOVE_ENTITY_LIST,
+  NET_REQUEST_CREATE,
+  NET_REQUEST_REMOVE,
+  NET_REQUEST_SYNC,
+  NET_YOU_ARE_ENTITY,
+  NET_REQUEST_ENTITY_LIST,
+  NET_REQUEST_PNODE_PATH,
+
+  NET_NUMBER
 };
 
Index: /branches/network/src/lib/network/network_manager.cc
===================================================================
--- /branches/network/src/lib/network/network_manager.cc	(revision 6664)
+++ /branches/network/src/lib/network/network_manager.cc	(revision 6665)
@@ -163,7 +163,5 @@
       if( static_cast<NetworkStream*>(*stream)->isActive())
         static_cast<NetworkStream*>(*stream)->processData();
-
   }
-
 }
 