Index: code/branches/ppspickups2/data/levels/includes/pickups_invisible.oxi
===================================================================
--- code/branches/ppspickups2/data/levels/includes/pickups_invisible.oxi	(revision 6685)
+++ code/branches/ppspickups2/data/levels/includes/pickups_invisible.oxi	(revision 6689)
@@ -1,9 +1,29 @@
 <PickupRepresentation
-    name = "Invisibility"
-    description = "Makes you invisible."
-    spawnerTemplate = "invisiblepickupRepresentation"
+    name = "small Invisibility"
+    description = "Makes you invisible for 5 seconds."
+    spawnerTemplate = "smallinvisiblepickupRepresentation"
 >
     <pickup>
-        <InvisiblePickup template=invisiblepickup />
+        <InvisiblePickup template=smallinvisiblepickup />
     </pickup>
 </PickupRepresentation>
+
+<PickupRepresentation
+    name = "medium Invisibility"
+    description = "Makes you invisible for 10 seconds."
+    spawnerTemplate = "mediuminvisiblepickupRepresentation"
+>
+    <pickup>
+        <InvisiblePickup template=mediuminvisiblepickup />
+    </pickup>
+</PickupRepresentation>
+
+<PickupRepresentation
+    name = "hunge Invisibility"
+    description = "Makes you invisible for 20 seconds."
+    spawnerTemplate = "hugeinvisiblepickupRepresentation"
+>
+    <pickup>
+        <InvisiblePickup template=hugeinvisiblepickup />
+    </pickup>
+</PickupRepresentation>
Index: code/branches/ppspickups2/data/levels/pickup_pps_invi.oxw
===================================================================
--- code/branches/ppspickups2/data/levels/pickup_pps_invi.oxw	(revision 6685)
+++ code/branches/ppspickups2/data/levels/pickup_pps_invi.oxw	(revision 6689)
@@ -25,8 +25,19 @@
     <PickupSpawner position="-75,0,-100" triggerDistance="10" respawnTime="5" maxSpawnedItems="10">
         <pickup>
-            <InvisiblePickup template=invisiblepickup />
+            <InvisiblePickup template=smallinvisiblepickup />
         </pickup>
     </PickupSpawner>
 
+    <PickupSpawner position="-50,0,-100" triggerDistance="10" respawnTime="5" maxSpawnedItems="10">
+        <pickup>
+            <InvisiblePickup template=mediuminvisiblepickup />
+        </pickup>
+    </PickupSpawner>
+
+    <PickupSpawner position="-25,0,-100" triggerDistance="10" respawnTime="5" maxSpawnedItems="10">
+        <pickup>
+            <InvisiblePickup template=hugeinvisiblepickup />
+        </pickup>
+    </PickupSpawner>
 
     <Light type=directional position="0,0,0" direction="0.253, 0.593, -0.765" diffuse="1.0, 0.9, 0.9, 1.0" specular="1.0, 0.9, 0.9, 1.0" />
Index: code/branches/ppspickups2/data/levels/templates/pickup_representation_templates_invisible.oxt
===================================================================
--- code/branches/ppspickups2/data/levels/templates/pickup_representation_templates_invisible.oxt	(revision 6685)
+++ code/branches/ppspickups2/data/levels/templates/pickup_representation_templates_invisible.oxt	(revision 6689)
@@ -6,5 +6,5 @@
                     <Billboard position="0,0,0" colour="0.22,0.32,0.86" material="Sphere2" scale=0.1>
                         <attached>
-                            <Billboard position="0,0,0" colour="0.06,0.14,0.63" material="Eye" scale=0.1 />
+                            <Billboard position="0,0,0" colour="0.06,0.14,0.63" material="Eye" scale=0.5 />
                         </attached>
                     </Billboard>
@@ -15,5 +15,5 @@
 </Template>
 
-<Template name=smalltinvisiblepickup>
+<Template name=smallinvisiblepickup>
   <InvisiblePickup 
     duration = 5.0
@@ -30,5 +30,5 @@
                     <Billboard position="0,0,0" colour="0.22,0.32,0.86" material="Sphere2" scale=0.1>
                         <attached>
-                            <Billboard position="0,0,0" colour="0.06,0.14,0.63" material="Eye" scale=0.1 />
+                            <Billboard position="0,0,0" colour="0.06,0.14,0.63" material="Eye" scale=0.7 />
                         </attached>
                     </Billboard>
@@ -54,5 +54,5 @@
                     <Billboard position="0,0,0" colour="0.22,0.32,0.86" material="Sphere2" scale=0.1>
                         <attached>
-                            <Billboard position="0,0,0" colour="0.06,0.14,0.63" material="Eye" scale=0.1 />
+                            <Billboard position="0,0,0" colour="0.06,0.14,0.63" material="Eye" scale=0.9 />
                         </attached>
                     </Billboard>